int w, h, x, y, i, j, tmp;

//////////////////////////////   ///////////////////////////////

MaskedBitmap* bmpBelmont[7];   
bmpBelmont[0]=LoadMaskedBitmap("Images/Belmont1.bmp"); //
bmpBelmont[1]=LoadMaskedBitmap("Images/Belmont2.bmp"); // 
bmpBelmont[2]=LoadMaskedBitmap("Images/Belmont3.bmp"); // 
bmpBelmont[3]=LoadMaskedBitmap("Images/BelmontStrike1.bmp"); // 
bmpBelmont[4]=LoadMaskedBitmap("Images/BelmontStrike2.bmp"); //
bmpBelmont[5]=LoadMaskedBitmap("Images/BelmontStrike3.bmp"); //
bmpBelmont[6]=LoadMaskedBitmap("Images/BelmontSitJump.bmp"); //

/////////////////////    ////////////////////

// ,   ,   
const int FRAMES=91; //13+4+1+30+38+5 //   
int8_t movBelmont_SPR[FRAMES], movBelmont_DX[FRAMES], movBelmont_DY[FRAMES];
for (i=0; i<FRAMES; i++) //  
	movBelmont_SPR[i]=movBelmont_DX[i]=movBelmont_DY[i]=0;

// (13 )
i=0; const int HORIZ_MOVE=i, HORIZ_MOVE_COUNT=13;
tmp=i; for (j=0; j<HORIZ_MOVE_COUNT; j++) { //   DX=1  SPR=1
	movBelmont_DX[i]=movBelmont_SPR[i]=1; i++; } 
i=tmp;
movBelmont_SPR[i++]=0;	//SPR=0 ()  DX=1 (3 )
movBelmont_SPR[i++]=0;
movBelmont_SPR[i++]=0;
movBelmont_DX[i]=3; 	//SPR=1 ( )  DX=3 (1 )
i+=3; 					//...... DX=1 (2 )
movBelmont_SPR[i++]=2; 	//SPR=2 ( )  DX=1 (3 )
movBelmont_SPR[i++]=2;
movBelmont_SPR[i++]=2;
movBelmont_DX[i]=3; 	//SPR=1 ( )  DX=3 (1 )
i+=3; 					//...... DX=1 (2 )
movBelmont_SPR[i]=0; movBelmont_DX[i++]=0; //SPR=0 ()  DX=0 (1 )

//  (4 )
const int HORIZ_STRIKE=i, HORIZ_STRIKE_COUNT=4;
movBelmont_SPR[i++]=3;  //SPR=3 ()
movBelmont_SPR[i++]=4;  //SPR=4 ()
movBelmont_SPR[i++]=5;  //SPR=5 ()
i++;  					//SPR=0 ()

// (1 )
const int HORIZ_SIT=i, HORIZ_SIT_COUNT=1;
movBelmont_SPR[i++]=6; //SPR=6 ()

//  (30 )
const int VERT_JUMP=i, VERT_JUMP_COUNT=30;
for (j=3; j<=25; j++) //SPR=6 ()    3  25 
	movBelmont_SPR[i+j]=6; //(   -    )
for (j=0; j<10; j++)  	//DY=-3    0  9 (10 )
	movBelmont_DY[i++]=-3;
movBelmont_DY[i++]=-2;	//DY=-2 (3 )
movBelmont_DY[i++]=-2; 
movBelmont_DY[i++]=-2; 
movBelmont_DY[i++]=-1; //DY=-1 (1 )
movBelmont_DY[i++]=0;  //DY=0 (2 ) -  
movBelmont_DY[i++]=0; 
movBelmont_DY[i++]=1;  //DY=1 (1 ) -  
movBelmont_DY[i++]=2;  //DY=2 (3 )
movBelmont_DY[i++]=2; 
movBelmont_DY[i++]=2; 
for (j=0; j<6; j++) movBelmont_DY[i++]=3;  //DY=3 (6 )
for (j=0; j<4; j++) movBelmont_DY[i++]=3;  //DY=3 (4 )   SPR=0 

//  (38 )
const int HORIZ_JUMP=i, HORIZ_JUMP_COUNT=38;
for (j=0; j<HORIZ_JUMP_COUNT; j++) //DX=1      
	movBelmont_DX[i+j]=1;
for (j=4; j<=32; j++) //SPR=6 ()    4  32 
	movBelmont_SPR[i+j]=6; //(   -    )
movBelmont_DY[i]=-3; movBelmont_DX[i++]=2; //DX=2  DY=-3,-2 (4 )
movBelmont_DY[i]=-3; movBelmont_DX[i++]=2;
movBelmont_DY[i]=-2; movBelmont_DX[i++]=2;
movBelmont_DY[i]=-2; movBelmont_DX[i++]=2;
for (j=0; j<13; j++) movBelmont_DY[i++]=-2; //DY=-2 (13 )
movBelmont_DY[i++]=-1; //  (4 )
movBelmont_DY[i++]=0;  
movBelmont_DY[i++]=0;  
movBelmont_DY[i++]=1;  
for (j=0; j<13; j++) movBelmont_DY[i++]=2; //DY=2 (13 )
movBelmont_DY[i++]=2; //DY=2,3 (4 )
movBelmont_DY[i++]=2;  
movBelmont_DY[i++]=3;  
movBelmont_DY[i++]=3;  

//   (5 )
const int HORIZ_STRIKE_JMP=i, HORIZ_STRIKE_JMP_COUNT=5;  
i++; //SPR=0 ()
movBelmont_SPR[i]=5; //SPR=5 () (3 ) 
movBelmont_SPR[i]=5; 
movBelmont_SPR[i]=5; 
i++; //SPR=0 ()

///////////////////////////  - //////////////////////////////

// -
bool demoMode=true; //-  (  )
const int DEMO_STEPS=36; // -
char demoStep[DEMO_STEPS], demoIndex=1; //-   
bool demoJump; //    -

// 
const int DEMO_END=0;         // -
const int DEMO_WALK_RIGHT=1;  // 
const int DEMO_WALK_LEFT=2;   // 
const int DEMO_STRIKE=3;      // 
const int DEMO_HORIZ_JUMP=4;  //.
const int DEMO_SIT=5;         //

// - 
for (j=0; j<DEMO_STEPS; j++) demoStep[j]=DEMO_WALK_RIGHT; //  
// 0 -  ( )
// 
demoStep[3]=DEMO_STRIKE; // 3 - 
// 
demoStep[9]=DEMO_HORIZ_JUMP; // 9 - 
for (j=15; j<=17; j++) demoStep[j]=DEMO_WALK_LEFT; // 15..17 -  
for (j=18; j<=27; j++) demoStep[j]=DEMO_SIT; // 18..27 - 
for (j=28; j<=32; j++) demoStep[j]=DEMO_WALK_LEFT; // 28..32 -  
//   
demoStep[34]=DEMO_STRIKE; // 34 - 
demoStep[35]=DEMO_END; // 35 -  -


/////////////////////////////  ////////////////////////////////////

// 
int idxBelmont, nBelmont; //      
bool flipX=false; //    X ( .) 
bool noBreak; //     
			  //,        
// 
//       (  )
int idxStrikeBelmont=0, nStrikeBelmont; 
//       
bool strike_delay=false; //   
bool need_joy_strike;  //     
int strike_pause=0; //   ( )

//
bool pressed=false; //    
int key=0;	   //   
int new_key=0; //   (  )
int break_key1, break_key2, break_key3; //,   
			  //  ,       
//
int joy=0;    //  
int joy_activeAction; //  ,    
int joy_allowedActions; //,   .  

//
bool fixKalmicov=false; //    ( )
bool firstPass=true; //    

//  
x=8; y=187; PutSprite(bmpBelmont[movBelmont_SPR[idxBelmont++]],x,y,true,flipX,false);

//     (   -)
Keyboard::ReadKeyEx(new_key,pressed);

/////////////////////////////////  /////////////////////////////////////

//  
for (;;) {

demoJump=false; //   -

//   
lblReadKeys:

if (demoMode) { //    -
	Keyboard::ReadKeyEx(new_key,pressed); 
	if (pressed) { // ?
		if (firstPass) { 
			fixKalmicov=true; //  -  
			firstPass=false;
		} else
		if (!fixKalmicov) demoMode=false; //   
			else new_key=0; //    
	} 
	if (Joystick::GetState(joy)) if (!fixKalmicov) demoMode=false; 
}

lblKeys:
if (demoMode) { // -,      
   switch (demoStep[demoIndex++]) { 
   case DEMO_END: demoMode=false; new_key=key=0; goto lblKeys; //  
   case DEMO_WALK_RIGHT: new_key=KEY_RIGHT; break; //
   case DEMO_WALK_LEFT:  new_key=KEY_LEFT;  break; //
   case DEMO_STRIKE:     new_key=KEY_SPACE; break; //
   case DEMO_HORIZ_JUMP: new_key=KEY_RIGHT; demoJump=true; break; //
   case DEMO_SIT:        new_key=KEY_DOWN;  break; //
   } pressed=true; // 
} else { //  ,     
  fixKalmicov=false;
  while(true) {
    if (!pressed) Keyboard::ReadKeyEx(new_key,pressed); //
    if (Joystick::GetState(joy)) break; else strike_delay=false; //
    if (pressed) break;	
}}

//        
if (pressed) { if (new_key!=0) key=new_key; pressed=false; } else key=0;
joy_allowedActions=0; break_key1=break_key2=break_key3=1;

//  (,  )
if (strike_delay) if ((joy & JOY_BUTTONS)==0) strike_delay=false;
if ((key==KEY_SPACE || (joy & JOY_BUTTONS)!=0) && !strike_delay) { 

	idxBelmont=HORIZ_STRIKE; nBelmont=HORIZ_STRIKE_COUNT; // 
	noBreak=true; // 
	joy_activeAction=JOY_BUTTONS; //  
	if (key!=KEY_SPACE) { strike_delay=true; need_joy_strike=false; } //
	key=0; //    (    )

} else 

{ // 

// (  ,   ,    )
if (key==KEY_DOWN || (joy & JOY_DOWN)!=0) { 

	idxBelmont=HORIZ_SIT; nBelmont=HORIZ_SIT_COUNT; // 
	noBreak=false; //  ( )
 	joy_activeAction=JOY_DOWN; //  
	joy_allowedActions=JOY_BUTTONS;	//   
	need_joy_strike=true;

} else 

//
if (key==KEY_RIGHT || (joy & JOY_RIGHT)!=0) {
	flipX=false; //  

	//
	if (demoJump || (joy & JOY_UP)!=0) {
		idxBelmont=HORIZ_JUMP; nBelmont=HORIZ_JUMP_COUNT; // 
		noBreak=true; // 
		joy_activeAction=JOY_UP; //  
		break_key1=KEY_SPACE; //  
		joy_allowedActions=JOY_BUTTONS; //  
		key=0; //    (    )

	} else { //
		idxBelmont=HORIZ_MOVE; nBelmont=HORIZ_MOVE_COUNT; // 
		noBreak=false; // 
		joy_activeAction=JOY_RIGHT; //  
		// , , 
		break_key1=KEY_UP; break_key2=KEY_DOWN; break_key2=KEY_SPACE; //
		joy_allowedActions=JOY_BUTTONS|JOY_UP|JOY_DOWN; //
		need_joy_strike=true;
	}
} else 

//
if (key==KEY_LEFT || (joy & JOY_LEFT)!=0) { 
	flipX=true; //  

	//
	if (demoJump || (joy & JOY_UP)!=0) { 
		idxBelmont=HORIZ_JUMP; nBelmont=HORIZ_JUMP_COUNT; // 
		noBreak=true; // 
		joy_activeAction=JOY_UP; //  
		break_key1=KEY_SPACE; //  
		joy_allowedActions=JOY_BUTTONS; //  
		key=0; //    (    )

	} else { //
		idxBelmont=HORIZ_MOVE; nBelmont=13; // 
		noBreak=false; // 
		joy_activeAction=JOY_LEFT; //  
		// , , 
		break_key1=KEY_UP; break_key2=KEY_DOWN; break_key2=KEY_SPACE; //
		joy_allowedActions=JOY_BUTTONS|JOY_UP|JOY_DOWN; //
		need_joy_strike=true;
	}
} else 

// 
if ((key==KEY_UP) || ((joy & JOY_UP)!=0)) { 

	idxBelmont=VERT_JUMP; nBelmont=VERT_JUMP_COUNT; // 
	noBreak=true; // 
	joy_activeAction=JOY_UP; //  
	break_key1=KEY_SPACE; //  
	joy_allowedActions=JOY_BUTTONS; //  
	key=0; //    (    )

} else 

// 
{ joy_activeAction=0; goto lblReadKeys; }

if (strike_delay) joy_allowedActions&=~JOY_BUTTONS; //  

} //  
 
///////////////////////////    //////////////////////////

while ((nBelmont--)>0) { //     

 // 
 if (flipX) x-=movBelmont_DX[idxBelmont]; //X 
 	else x+=movBelmont_DX[idxBelmont]; //X 
 y+=movBelmont_DY[idxBelmont]; //Y
 
 // 
 if (nStrikeBelmont>0) { //  (   )
	nStrikeBelmont--;
	MoveSprite(bmpBelmont[movBelmont_SPR[idxStrikeBelmont++]],x,y,true,flipX,false);
} else // 
  	MoveSprite(bmpBelmont[movBelmont_SPR[idxBelmont]],x,y,true,flipX,false);
 
 idxBelmont++; //   

 //    (    )
 if (!fixKalmicov) { 
	Keyboard::ReadKeyEx(new_key,pressed); 
	if (pressed || Joystick::GetState(joy)) demoMode=false;
 }

 // - ,    
 //   "" -
 if (demoMode) { joy=0; new_key=0; pressed=true; }

 //    (     )
 if (strike_delay) if ((joy & JOY_BUTTONS)==0) { strike_delay=false;
	if (need_joy_strike) joy_allowedActions|=JOY_BUTTONS; }

 //     
 if (//     
	//((new_key==break_key1) || (new_key==break_key2) || (new_key==break_key3)
	  ((new_key-break_key1) & (new_key-break_key2) & (new_key-break_key3))==0
	
	//     
	|| ((joy & joy_allowedActions)!=0) 
	 
	//     
	//        ( )
	//|| ((joy & joy_activeAction)==0 &&  (!pressed || (new_key!=0 && key!=new_key)))) {
	  || ((joy & joy_activeAction)==0 && (!pressed || ((new_key & (key-new_key))!=0)))) {

 	
	if (noBreak) { //    
        //   ,   

		//   ,   
		if (strike_pause>0) --strike_pause; else 
	
		//       ,    
		if ((new_key==KEY_SPACE || (joy & JOY_BUTTONS)!=0) && nStrikeBelmont==0) { 
			idxStrikeBelmont=HORIZ_STRIKE_JMP; nStrikeBelmont=HORIZ_STRIKE_JMP_COUNT; // 
	 	   	if (new_key!=KEY_SPACE) strike_pause=8; //    
				else if (joy_activeAction==JOY_UP) strike_pause=4; // 
				else strike_pause=1; // 
		}
		key=0; //  ,     

	} else { //  
  
	   MoveSprite(bmpBelmont[movBelmont_SPR[0]],x,y,true,flipX,false); //  
 	   break; //  
	}
 } //if ()

} //while ((nBelmont--)>0)

///////////////////////////    //////////////////////////

//    
if (nStrikeBelmont>0) MoveSprite(bmpBelmont[movBelmont_SPR[0]],x,y,true,flipX,false);
strike_pause=0; nStrikeBelmont=0;

} //c   ( )
